define(['table','form'], function (Table,Form) {
    Table.init = {
        table_elem: 'list',
        tableId: 'list',
        requests:{
            index_url: 'addons/mocms/backend/cmsSearchHistory/index',
            edit_url: 'addons/mocms/backend/cmsSearchHistory/edit',
            delete_url: 'addons/mocms/backend/cmsSearchHistory/delete',
            modify_url: 'addons/mocms/backend/cmsSearchHistory/modify',
            recycle_url: 'addons/mocms/backend/cmsSearchHistory/recycle',
            destroy_url: 'addons/mocms/backend/cmsSearchHistory/destroy',
            restore_url: 'addons/mocms/backend/cmsSearchHistory/restore',
        }
    }
    let Controller = {
        index: function () {
            Table.render({
                elem: '#' + Table.init.table_elem,
                id: Table.init.tableId,
                url: Fun.url(Table.init.requests.index_url),
                init: Table.init,
                toolbar: ['refresh','add_full','destroy','recycle'],
                cols: [[
                    {checkbox: true, fixed: true},
                    {field: 'keyword', title: __('keyword'), minwidth: 150, fixed: true, sort: true},
                    {field: 'nums', title: __('nums'), minwidth: 150,  true, sort: true},
                    {field: 'site_id', title: __('SiteId'), minwidth: 50,  sort: true},
                    {field: 'member.username', title: __('Username'), width: 150,},
                    {field: 'search_date', title: __('searchDate'), width: 110, sort: true},
                    {field: 'ip', title: __('ip'), width: 110, sort: true},
                    {field: 'create_time', title: __('Createtime'), width: 180, sort: true},
                    // {field: 'update_time', title: __('Updatetime'), width: 180, sort: true},
                    {
                        width: 250, align: 'center', title: __('Operat'), init: Table.init,
                        templet : Table.templet.operat, operat: ['edit','destroy','delete']
                    }
                ]],
                done: function(res){

                },
                //
                limits: [10, 15, 20, 25, 50, 100],
                limit: 50,
                page: true
            });

            let table = $('#'+Table.init.table_elem);
            Table.api.bindEvent(table);
        },
        add: function () {
            Controller.api.bindevent()
        },
        edit: function () {
            Controller.api.bindevent()
        },
        recycle: function () {
            Table.render({
                elem: '#' + Table.init.table_elem,
                id: Table.init.tableId,
                url: Fun.url(Table.init.requests.recycle_url),
                init: Table.init,
                toolbar: ['refresh','delete','restore'],
                cols: [[
                    {checkbox: true, fixed: true},
                    {checkbox: true, fixed: true},
                    {field: 'keyword', title: __('keyword'), minwidth: 150, fixed: true, sort: true},
                    {field: 'nums', title: __('nums'), minwidth: 150,  true, sort: true},
                    {field: 'site_id', title: __('SiteId'), minwidth: 50,  sort: true},
                    {field: 'member.username', title: __('Username'), width: 150,},
                    {field: 'search_date', title: __('searchDate'), width: 110, sort: true},
                    {field: 'ip', title: __('ip'), width: 110, sort: true},
                    {field: 'create_time', title: __('Createtime'), width: 180, sort: true},
                    {
                        width: 250, align: 'center', title: __('Operat'), init: Table.init,
                        templet : Table.templet.operat, operat: ['delete','restore']
                    }
                ]],
                done: function(res){

                },
                //
                limits: [10, 15, 20, 25, 50, 100],
                limit: 50,
                page: true
            });

            let table = $('#'+Table.init.table_elem);
            Table.api.bindEvent(table);
        },
        api: {
            bindevent: function () {
                Form.api.bindEvent($('form'))
            }
        }

    };
    return Controller;
});